Main:
  #include "LegoLibrary.bas"
  BluetoothPort = 34
  RangePort = 3
  call LegoInit(BluetoothPort)
  call LegoRangeInit(RangePort)
  gosub FindWall
  call FollowWall(5) // follow for 5 feet
end

FindWall:
  gosub LegoLookAhead
  repeat
    call LegoRangeSensor(RangePort,r1)
    if r1 > 10
      call LegoDriveMotors(FAST,FAST)
    else
      call LegoDriveMotors(SLOW,SLOW)
    endif
  until r1<6
  gosub LegoFaceRight
return

sub FollowWall(dist)
  gosub LegoLookLeft
  if _LegoSimulation
    m=dist*700
  else
    m=dist*20
  endif 
  for i=1 to m
    call LegoRangeSensor(_RangePort,R)
    if R<10
      // move away from wall
      gosub LegoEasyRight
    else
      // move closer to wall
      gosub LegoEasyLeft
    endif
  next
  gosub LegoHalt
return
